%normalize segmented mouth images
%and calculate shape features 


function features=shape_features(im)
format long;
%data input
mouth=double(im2bw(im));
% figure; imshow(mouth)
[x,y]=size(mouth);
% figure; imshow(mouth)
%find leftmost and rightmost points
[i,j]=find(mouth==1);
n=length(j);
left_point=[ j(1), i(1)];
right_point=[j(n), i(n)];

%image normalization by landmark based registration
input=[left_point; right_point];
base=[1,50; 100,50];
mytform = cp2tform(input, base, 'linear conformal');
reg_mouth = imtransform(mouth, mytform);
reg_mouth=double(im2bw(reg_mouth));
% figure; imshow(reg_mouth)

%divide the mouth in two and calculate ratio
[x,y]=size(reg_mouth);
mouth_up=reg_mouth(1:x/2,:);
mouth_down=reg_mouth(x/2:x,:);
stats_up = regionprops(mouth_up, 'Area');
stats_down = regionprops(mouth_down, 'Area');
area_up=stats_up.Area;
area_down=stats_down.Area;
ratio=area_up/area_down;

%calculate normalized mouth shape features
stats = regionprops(reg_mouth, 'Centroid', 'ConvexArea','Area', 'MinorAxisLength', 'Eccentricity', 'Orientation');
cent=stats.Centroid;
cm1=cent(1);
cm2=cent(2);
ar=stats.Area;
ma=stats.MinorAxisLength;
ec=stats.Eccentricity;
or=stats.Orientation;
cv=stats.ConvexArea;

features_un=[ma,ec,or,cv,ratio];
features = zscore(features_un); %normalize features

end


    
    